*******************************************************************************
*   File........: Demo2.prg
*   Date........: May 12, 1994
*   Author......: Ly Minh Tr (CIS 73062,512)
*   Copyright...: Copyright (c) 1993, Tri M. Ly
*   Version.....: 2.02
*******************************************************************************
#DEFINE K_LEFTJUST          "L"
#DEFINE K_CENTERJUST        "C"
#DEFINE K_RIGHTJUST         "R"

#DEFINE K_NORMALSTYLE       "N"
#DEFINE K_BOLDSTYLE         "B"
#DEFINE K_ITALICSTYLE       "I"
#DEFINE K_ITALICBOLDSTYLE   "BI"

#DEFINE K_OK                "OK"
#DEFINE K_CONTINUE          "C"
#DEFINE K_OKCANCEL          "OKC"
#DEFINE K_YESNO             "YN"
#DEFINE K_YESNOCANCEL       "YNC"
#DEFINE K_RETRYCANCEL       "RC"
#DEFINE K_ABORTRETRYIGNORE  "ARI"

IF _WINDOWS
    K_ICONHAND          = "BITMAPS->STOP"
    K_ICONQUESTION      = "BITMAPS->QUESTION"
    K_ICONEXCLAMATION   = "BITMAPS->EXCLAIM"
    K_ICONASTERISK      = "BITMAPS->INFO"
    K_ICONINFORMATION   = "BITMAPS->INFO"
    K_ICONSTOP          = K_ICONHAND
ELSE
    K_ICONHAND          = "HAND"
    K_ICONQUESTION      = "?"
    K_ICONEXCLAMATION   = "!"
    K_ICONASTERISK      = "*"
    K_ICONINFORMATION   = "INFO"
    K_ICONSTOP          = K_ICONHAND
ENDIF

#DEFINE K_USAFLAG           SYS(2003) + "\USFLAG.BMP SIZE 3,10"

#DEFINE K_1LINE             CHR(13)
#DEFINE K_2LINE             K_1LINE+K_1LINE

*
* Character Code Colors to use with WMsgBox()
*
#DEFINE K_BLACK             "{N}"
#DEFINE K_BLUE              "{B+}"
#DEFINE K_CYAN              "{BG+}"
#DEFINE K_DRKBLUE           "{B}"
#DEFINE K_DRKCYAN           "{BG}"
#DEFINE K_DRKGREEN          "{G}"
#DEFINE K_DRKMAGENTA        "{RB}"
#DEFINE K_DRKRED            "{R}"
#DEFINE K_DRKYELLOW         "{GR}"
#DEFINE K_DRKGRAY           "{N+}"
#DEFINE K_GRAY              "{W}"
#DEFINE K_GREEN             "{G+}"
#DEFINE K_MAGENTA           "{RB+}"
#DEFINE K_RED               "{R+}"
#DEFINE K_WHITE             "{W+}"
#DEFINE K_YELLOW            "{GR+}"

USE bitmaps ALIAS bitmaps

cmsg    = "This demo is from the examples" + K_1LINE + ;
          "in the documentation."
ctitle  = "Examples"
cprompt = "okc"
ctype   = "BITMAPS->QUESTION"
nrow    = -1
ncol    = -1
cpad    = K_LEFTJUST
cfont   = WFONT(1, "COMMAND")
nsize   = WFONT(2, "COMMAND")
cstyle  = WFONT(3, "COMMAND")
ccolor  = "RGB(128,128,128,255,255,255)"
ccolor  = 4
nnumeric= 0

= wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric)

= wmsgbox("Are you sure you want to delete" + CHR(13) + ;
          "this record?", "Delete Record", K_ICONQUESTION, ;
          K_YESNO)

= wmsgbox("Select an analysis to perform...", "Analysis", ;
          K_ICONQUESTION, "\<pH;\<H2SO4;\<HCl;\?\<Exit")

IF _WINDOWS
    cprompt = SYS(2004) + "goodies\bitmaps\arrows\point02.bmp;" + ;
              SYS(2004) + "goodies\bitmaps\arrows\point03.bmp;" + ;
              SYS(2004) + "goodies\bitmaps\arrows\point04.bmp;" + ;
              SYS(2004) + "goodies\bitmaps\arrows\point05.bmp" + ;
              " SIZE 4,8"
ELSE
    cprompt = "\<Left;\<Down;\<Right;\<Up"
ENDIF
= wmsgbox("Select a direction to go next...", "Cross-Path", ;
          K_ICONASTERISK, cprompt)
cprompt = "okc"

= wmsgbox("Power User demands flexibility!", ;
          "Power", "bitmaps->exclaim", K_OK, -1, -1, K_CENTERJUST, ;
          "Times New Roman", 12, "BI")
*
* Color pair style color specifcation...
*
cclrpair = "R+/GR+"
= wmsgbox("Color pair R+/GR+!", ;
          "Color Test", K_ICONEXCLAMATION, K_OK, -1, -1, K_LEFTJUST, ;
          "Times New Roman", 12, "B", cclrpair)
*
* Color scheme style color specifcation...note that you pass in the
* scheme number!
*
nclrscheme = 7
= wmsgbox("Color scheme 7!", ;
          "Color Test", K_ICONEXCLAMATION, K_OK, -1, -1, K_LEFTJUST, ;
          "Times New Roman", 12, "BI", nclrscheme)
*
* RGB(...) style color specifcation...note that it must be enclosed
* in quotes!
*
cclrrgb = "RGB(255,255,255,128,128,128)"
= wmsgbox("RGB(...) style color!", ;
          "Color Test", K_ICONEXCLAMATION, K_OK, -1, -1, K_LEFTJUST, ;
          "Times New Roman", 12, "BI", cclrrgb)

*
* Specifying color for individual message line.
*
cclrpair = "W/BG+"
= wmsgbox("I pledge allegiance to the flag" + K_RED + CHR(13) + ;
          "of the United States of America," + K_WHITE + CHR(13) + ;
          "and to the Republic for which it" + K_BLUE + CHR(13) + ;
          "stands, one nation under God," + K_RED + CHR(13) + ;
          "indivisible, with liberty and" + K_WHITE + CHR(13) + ;
          "and justice for all." + K_BLUE, ;
          "Pledge of Allegiance", "", IIF(_WINDOWS, K_USAFLAG, K_OK), -1, -1, ;
          K_CENTERJUST, "Times New Roman", 14, "B", cclrpair)

*
* Specifying help message for each button
*
chelpmesg = "Select YES if you see message;" + ;
            "Select NO if no message is visible"
= wmsgbox("Do you see the message at the bottom of" + CHR(13) + ;
          "the main window or in the status bar?", "Help Message", ;
          K_ICONQUESTION, K_YESNO, -1, -1, "", "", 0, "", "", 0, chelpmesg)

*
* Specifying user-defined VALID routine
*
chelpmesg = "Select YES if you see message;" + ;
            "Select NO if no message is visible;" + ;
            "Select HELP to invoke Help"
= wmsgbox("Do you see the message at the bottom of" + CHR(13) + ;
          "the main window or in the status bar?", "Help Message", ;
          K_ICONQUESTION, "Yes;No;Help", -1, -1, "", "", ;
          0, "", "", 0, chelpmesg, "MY_VALID")

*
* Specifying user-defined window border style
*
cborder   = "ĳڿ"
= wmsgbox("Do you see this dialog with" + CHR(13) + ;
          "a single border?", "Border Style", ;
          K_ICONQUESTION, K_YESNO, -1, -1, "", "", ;
          0, "", "", 0, "", "", cborder)

USE
RETURN


FUNCTION my_valid
    IF _CUROBJ == 3
        HELP
        RETURN 0
    ENDIF
RETURN .T.
